from lxml import etree
from datetime import datetime

# Load the database file
tree = etree.parse('Database.xml')

# Find the element that's the parent of all the
# 'new ideas', in this case we know it's z2868
new_ideas_group = tree.find("object[@id='z2868']")

# Find the element that contains the IDs of all the new ideas
new_idea_children = new_ideas_group.find("relationship[@name='children']")

# Turn it into a list
new_ideas_ids= new_idea_children.attrib['idrefs'].split()

# Grab each etree element and put it in a list
ideas = []

for id in new_ideas_ids:
	ideas.append(tree.find("object[@id='" + id + "']"))

# Sort the list by date	
def extract_date(element):
	return element.find("attribute[@name='datecreated']").text	

ideas.sort(key=extract_date)


# Now print out a CSV in the format:
# date, cumulative idea count
total_count = 0

for idea in ideas:
	total_count += 1
	
	# Apple time is derived from a Jan 1 2001 epoch.
	# Adding 978328800 seconds gets us back to Unix time.
	print str(datetime.fromtimestamp(int(extract_date(idea)[0:9]) + 978328800)) + ',' + str(total_count)